

arch/i386/kernel/irq.c: In function `is_irq_stack_ptr':
arch/i386/kernel/irq.c:199: `hardirq_stack' undeclared (first use in this function)
arch/i386/kernel/irq.c:199: (Each undeclared identifier is reported only once
arch/i386/kernel/irq.c:199: for each function it appears in.)
arch/i386/kernel/irq.c:202: `softirq_stack' undeclared (first use in this function)

Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/arch/i386/kernel/irq.c     |   22 +++++++++++-----------
 25-akpm/include/asm-i386/hardirq.h |    8 ++++++++
 2 files changed, 19 insertions(+), 11 deletions(-)

diff -puN arch/i386/kernel/irq.c~fix-of-stack-dump-in-soft-hardirqs-build-fix arch/i386/kernel/irq.c
--- 25/arch/i386/kernel/irq.c~fix-of-stack-dump-in-soft-hardirqs-build-fix	2004-10-01 18:24:56.397090840 -0700
+++ 25-akpm/arch/i386/kernel/irq.c	2004-10-01 18:24:56.402090080 -0700
@@ -178,18 +178,7 @@ asmlinkage void do_softirq(void)
 
 	local_irq_restore(flags);
 }
-
 EXPORT_SYMBOL(do_softirq);
-#endif
-
-/*
- * Interrupt statistics:
- */
-
-atomic_t irq_err_count;
-#if defined(CONFIG_X86_IO_APIC) && defined(APIC_MISMATCH_DEBUG)
-atomic_t irq_mis_count;
-#endif
 
 int is_irq_stack_ptr(struct task_struct *task, void *p)
 {
@@ -206,6 +195,17 @@ int is_irq_stack_ptr(struct task_struct 
 	return 0;
 }
 
+#endif
+
+/*
+ * Interrupt statistics:
+ */
+
+atomic_t irq_err_count;
+#if defined(CONFIG_X86_IO_APIC) && defined(APIC_MISMATCH_DEBUG)
+atomic_t irq_mis_count;
+#endif
+
 /*
  * /proc/interrupts printing:
  */
diff -puN include/asm-i386/hardirq.h~fix-of-stack-dump-in-soft-hardirqs-build-fix include/asm-i386/hardirq.h
--- 25/include/asm-i386/hardirq.h~fix-of-stack-dump-in-soft-hardirqs-build-fix	2004-10-01 18:24:56.398090688 -0700
+++ 25-akpm/include/asm-i386/hardirq.h	2004-10-01 18:24:56.402090080 -0700
@@ -37,6 +37,14 @@ static inline void ack_bad_irq(unsigned 
 }
 
 struct task_struct;
+
+#ifdef CONFIG_4KSTACKS
 int is_irq_stack_ptr(struct task_struct *task, void *p);
+#else
+static inline int is_irq_stack_ptr(struct task_struct *task, void *p)
+{
+	return 0;
+}
+#endif
 
 #endif /* __ASM_HARDIRQ_H */
_
